Partially update customer details - Fabric

Partially update customer details

cURL

curl --request PATCH \
  --url https://api.fabric.inc/v3/customers/{customerId} \
  --header 'Authorization: Bearer <token>' \
  --header 'Content-Type: application/json' \
  --data '
{
  "name": {
    "title": "Dr.",
    "firstName": "Pat",
    "middleName": "E",
    "lastName": "Kake",
    "suffix": "Jr."
  },
  "emailAddress": "test@example.com",
  "phone": {
    "number": 15555551234,
    "type": "MOBILE"
  },
  "externalId": "1231012312-312-31231asda",
  "additionalAttributes": {
    "middleName": "user"
  }
}
'

Python

import requests

url = "https://api.fabric.inc/v3/customers/{customerId}"

payload = {
    "name": {
        "title": "Dr.",
        "firstName": "Pat",
        "middleName": "E",
        "lastName": "Kake",
        "suffix": "Jr."
    },
    "emailAddress": "test@example.com",
    "phone": {
        "number": 15555551234,
        "type": "MOBILE"
    },
    "externalId": "1231012312-312-31231asda",
    "additionalAttributes": { "middleName": "user" }
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.text)

JavaScript (Fetch API)

const options = {
  method: 'PATCH',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: JSON.stringify({
    name: {
      title: 'Dr.',
      firstName: 'Pat',
      middleName: 'E',
      lastName: 'Kake',
      suffix: 'Jr.'
    },
    emailAddress: 'test@example.com',
    phone: {number: 15555551234, type: 'MOBILE'},
    externalId: '1231012312-312-31231asda',
    additionalAttributes: {middleName: 'user'}
  })
};

fetch('https://api.fabric.inc/v3/customers/{customerId}', options)
  .then(res => res.json())
  .then(res => console.log(res))
  .catch(err => console.error(err));

PHP

<?php

$curl = curl_init();

curl_setopt_array($curl, [
  CURLOPT_URL => "https://api.fabric.inc/v3/customers/{customerId}",
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_ENCODING => "",
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 30,
  CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
  CURLOPT_CUSTOMREQUEST => "PATCH",
  CURLOPT_POSTFIELDS => json_encode([
    'name' => [
        'title' => 'Dr.',
        'firstName' => 'Pat',
        'middleName' => 'E',
        'lastName' => 'Kake',
        'suffix' => 'Jr.'
    ],
    'emailAddress' => 'test@example.com',
    'phone' => [
        'number' => 15555551234,
        'type' => 'MOBILE'
    ],
    'externalId' => '1231012312-312-31231asda',
    'additionalAttributes' => [
        'middleName' => 'user'
    ]
  ]),
  CURLOPT_HTTPHEADER => [
    "Authorization: Bearer <token>",
    "Content-Type: application/json"
  ],
]);

$response = curl_exec($curl);
$err = curl_error($curl);

curl_close($curl);

if ($err) {
  echo "cURL Error #:" . $err;
} else {
  echo $response;
}
?>

Go

package main

import (
    "fmt"
    "strings"
    "net/http"
    "io"
)

func main() {

url := "https://api.fabric.inc/v3/customers/{customerId}"

payload := strings.NewReader("{\n  \"name\": {\n    \"title\": \"Dr.\",\n    \"firstName\": \"Pat\",\n    \"middleName\": \"E\",\n    \"lastName\": \"Kake\",\n    \"suffix\": \"Jr.\"\n  },\n  \"emailAddress\": \"test@example.com\",\n  \"phone\": {\n    \"number\": 15555551234,\n    \"type\": \"MOBILE\"\n  },\n  \"externalId\": \"1231012312-312-31231asda\",\n  \"additionalAttributes\": {\n    \"middleName\": \"user\"\n  }\n}")

req, _ := http.NewRequest("PATCH", url, payload)

req.Header.Add("Authorization", "Bearer <token>")
    req.Header.Add("Content-Type", "application/json")

res, _ := http.DefaultClient.Do(req)

defer res.Body.Close()
    body, _ := io.ReadAll(res.Body)

fmt.Println(string(body))
}

Response Format

The response is expected to be in the following JSON format:

{
  "id": "61df41892bf06d00092d0d8a",
  "name": {
    "firstName": "Pat",
    "lastName": "Doe",
    "title": "Dr.",
    "middleName": "E",
    "suffix": "Jr."
  },
  "emailAddress": "test@example.com",
  "isDeleted": false,
  "createdAt": "2023-08-30T23:20:42.822Z",
  "updatedAt": "2023-08-30T23:20:42.822Z",
  "status": "ACTIVE",
  "phone": {
    "number": 15555551234,
    "type": "MOBILE"
  },
  "externalId": "1231012312-312-31231asda",
  "additionalAttributes": {
    "middleName": "user"
  },
  "deletedAt": "2023-08-30T23:20:42.822Z",
  "defaultAddress": [
    {
      "id": "61604a30fdfacd0009816e44",
      "address": {
        "type": "BILLING",
        "addressLine1": "123 Main St.",
        "addressLine2": "Suite 100",
        "addressLine3": "Seventh floor",
        "addressLine4": "Attention: Pat E. Doe",
        "city": "Seattle",
        "region": "WA",
        "postalCode": 98121,
        "county": "King County",
        "country": "US",
        "latitude": 47.6205,
        "longitude": -122.3493
      },
      "isDeleted": false,
      "createdAt": "2023-08-30T23:20:42.822Z",
      "updatedAt": "2023-08-30T23:20:42.822Z",
      "additionalAttributes": {
        "landmark": "Beach"
      },
      "isDefault": false,
      "deletedAt": "2023-08-30T23:20:42.822Z"
    }
  ]
}

Error Responses

Authorization

Authorization header is required. The access token must be provided to successfully make the PATCH request.